routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\CompaniesController;
use App\Http\Controllers\EmployeesController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\ItemsController;
use App\Http\Controllers\SellController;
use App\Http\Controllers\SellSummaryController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => 'App\Http\Controllers\LanguageController@switchLang']);

Auth::routes(['register' => false, 'reset' => false]);

Route::group(['middleware' => 'auth', 'checktoken'], function () {
    Route::get('/', [CompaniesController::class, 'index']); 
    Route::get('home', [CompaniesController::class, 'index']); 

    Route::get('/data-companies', [CompaniesController::class, 'dataCompanies']);

    Route::resource('companies', CompaniesController::class);

    Route::get('company/destroy/{id}', [CompaniesController::class, 'destroy']);


    Route::get('/data-employees', [EmployeesController::class, 'dataEmployees']);

    Route::resource('employees', EmployeesController::class);

    Route::get('employee/destroy/{id}', [EmployeesController::class, 'destroy']);


    Route::resource('items', ItemsController::class);

    Route::get('item/destroy/{id}', [ItemsController::class, 'destroy']);


    Route::resource('sell', SellController::class);

    Route::get('sell/destroy/{id}', [SellController::class, 'destroy']);

    Route::get('store-item-price/{id}', [SellController::class, 'storeItemPrice']);

    Route::resource('sell-summary', SellSummaryController::class);
});

app/Models/Items.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\Sell;
use App\Models\Items;
use DB;

class Items extends Model
{
    use HasFactory;

    protected $table = "items";
    protected $primaryKey = 'id';

    protected $fillable = [
        'name',
        'price',
        'created_at',
        'updated_at'
    ];

    public function sells()
    {
        return $this->hasMany(Sell::class);
    }

    public static function getItems() {
        DB::statement(DB::raw('set @rownum=0'));
        $data = Items::select([
            DB::raw('@rownum  := @rownum  + 1 AS rownum'),
            'id',
            'name',
            'price',
            'created_at',
        ]);

        return $data;
    }
}

app/Http/Controllers/ItemsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Items;
use App\Models\Timezone;
use Yajra\Datatables\Datatables;
use DB;
use App\Http\Requests\StoreItemRequest;
use App\Http\Traits\TimezoneTrait;
use App\Http\Traits\ItemsTrait;

class ItemsController extends Controller
{
    use TimezoneTrait;
    use ItemsTrait;
    
    /**
     * Display a listing of items.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if(!empty($request->timezone)){
            $this->setTimezone($request->timezone);
        }

        $timezones = Timezone::Orderby('offset')->get();

        if($request->ajax()){
            $items_datatable = $this->setItemsTable();

            return $items_datatable;
        }

        return view('items.items-index', compact('timezones'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreItemRequest $request)
    {
        $new_item = new Items();
        $new_item->name         =   $request->name;
        $new_item->price        =   $request->price;
        $new_item->created_at   =   now();
        $new_item->updated_at   =   now();
        $new_item->save();

        return response()->json(['success' => 'Data Added successfully.']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Items $item)
    {
        return view('items.item-detail', compact('item'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        if(request()->ajax())
        {
            $data = Items::findOrFail($id);
            return response()->json(['result' => $data]);
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(StoreItemRequest $request, Items $items)
    {
        $item = Items::find($request->hidden_id);
        $item->name         =   $request->name;
        $item->price        =   $request->price;
        $item->updated_at   =   now();
        $item->save();

        return response()->json(['success' => 'Data is successfully updated']);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $data = Items::findOrFail($id);
        $data->delete();
    }
}

resources/views/items/item-detail.blade.php
@extends('adminlte::page')

@section('title', trans('text.ItemDetail'))

@section('content_header')
    <h1> {{ trans('text.ItemDetail') }}</h1>
@stop

@section('content')<!doctype html>

    <table style="width:100%">
        <tr>
            <th>{{ trans('text.Name') }}</th>
            <td>{{$item->name}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.Price') }}</th>
            <td>@convert($item->price)</td>
        </tr>
    </table>
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
@stop

@section('js')
    <script> console.log('Hi!'); </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
@stop

resources/views/items/items-index.blade.php
@extends('adminlte::page')

@section('title', trans('text.Items List'))

@section('content_header')
    <h1>{{ trans('text.Items List') }}</h1>
@stop

@section('content')<!doctype html>
    <hr>
    <div class="container">
        <button type="button" name="create_record" id="create_record" class="btn btn-success" align="left"> {{ trans('text.Add') }} {{ trans('text.Item') }}</button>
    </div>
    <br/>

    <div class="container">
        <div class="row">
            <div class="col-md-4">
                <select data-column="5" class="form-control filter-select" name="timezone" id="timezone">
                    <option value="">{{ trans('text.Timezone') }}...</option>
                    @foreach($timezones as $timezone)
                        @if(session::get('timezone_id') == $timezone->id)
                            <option value="{{ $timezone->id }}" selected>{{ $timezone->name }} ({{ $timezone->offset }})</option>
                        @else
                            <option value="{{ $timezone->id }}">{{ $timezone->name }} ({{ $timezone->offset }})</option>
                        @endif
                    @endforeach
                </select>
            </div>
            <div class="col-md-1">
                <button type="button" name="filter" id="filter" class="btn btn-primary">Filter</button>
            </div>
        </div>
        <table class="table table-bordered" id="item_table">
            <thead>
                <tr>
                    <th>No.</th>
                    <th>{{trans('text.ItemName')}}</th>
                    <th>{{ trans('text.Price') }}</th>
                    <th>{{ trans('text.createdAt') }}</th>
                    <th width="25%">{{ trans('text.Action') }}</th>
                </tr>
            </thead>
            <tbody></tbody>
            <tfoot>
                <tr>
                    <td></td>
                    <td>
                        <input type="text" data-column="1" placeholder="{{trans('text.ItemName')}}...." class="form-control filter-input">
                    </td>
                    <td></td>
                    <td></td>
                    <td></td>
                </tr>
            </tfoot>
        </table>
    </div>

    <div id="formModal" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title"> {{ trans('text.Add') }} {{ trans('text.Item') }}</h4>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <span id="form_result"></span>
                    <form method="post" id="form_item" class="form-horizontal" enctype="multipart/form-data">
                        @csrf
                        <div class="form-group">
                            <label class="control-label col-md-4" >{{ trans('text.Name') }} : </label>
                            <div class="col-md-12">
                                <input type="text" name="name" id="name" class="form-control" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="control-label col-md-4">{{ trans('text.Price') }} : </label>
                            <div class="col-md-12">
                                <input type="text" name="price" id="price" class="form-control" />
                            </div>
                        </div>
                        <br />
                        <div class="form-group" align="center">
                            <input type="hidden" name="action" id="action" value="Add" />
                            <input type="hidden" name="hidden_id" id="hidden_id" />
                            <input type="submit" name="action_button" id="action_button" class="btn btn-success" value="Add Item" />
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <div id="confirmModal" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h3>{{ trans('text.Confirmation') }}</h3>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <p align="center" style="margin:0;">{{ trans('text.deleteConf') }}</p>
                </div>
                <div class="modal-footer">
                    <button type="button" name="ok_button" id="ok_button" class="btn btn-danger">OK</button>
                    <button type="button" class="btn btn-default" data-dismiss="modal">{{ trans('text.Cancel') }}</button>
                </div>
            </div>
        </div>
    </div>
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
@stop

@section('js')
    <script> console.log('Hi!'); </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
    <script>
        $(document).ready(function(){

            load_data();

            function load_data(timezone = ''){
                var t = $('#item_table').DataTable({
                    processing: true,
                    serverSide: true,
                    bLengthChange: false,
                    ajax: {
                        url: "{{ route('items.index') }}",
                        data: {timezone:timezone}
                    },
                    columns: [
                        {
                            data: 'rownum',
                            name: 'rownum'
                        },
                        {
                            data: 'name',
                            name: 'name'
                        },
                        {
                            data: 'price',
                            name: 'price'
                        },
                        {
                            data: 'created_at',
                            name: 'created_at'
                        },
                        {
                            data: 'action',
                            name: 'action',
                            orderable: false
                        }
                    ],
                    "columnDefs": [ {
                        "searchable": false,
                        "orderable": false,
                        "targets": 0
                    } ],
                    "order": [[ 1, 'asc' ]]
                });

                $('.filter-input').keyup(function(){
                    t.column( $(this).data('column'))
                        .search($(this).val())
                        .draw();
                });

                t.on( 'order.dt search.dt', function () {
                    t.column(0, {search:'applied', order:'applied'}).nodes().each( function (cell, i) {
                        cell.innerHTML = i+1;
                    } );
                } ).draw();
            };

            $('#filter').click(function() {
                var timezone = $('#timezone').val();
                if(timezone != ''){
                    $('#item_table').DataTable().destroy();
                    load_data(timezone);
                };
            });  

            $('#create_record').click(function(){
                $('.modal-title').text('{{trans("text.Add")}} {{trans("text.Item")}}');
                $('#action_button').val('{{trans("text.Add")}}');
                $('#action').val('Add');
                $('#form_result').html('');
                $('#formModal').modal('show');
                $('#name').val(null);
                $('#price').val(null);
            });

            $('#form_item').on('submit', function(event){
                event.preventDefault();
                var action_url = '';
                var action_method = '';

                if($('#action').val() == 'Add') {
                    action_url = "{{ route('items.store') }}";
                    action_method = "POST";
                }

                if($('#action').val() == 'Edit') {
                    action_url = "{{ route('items.update', ':hidden_id') }}";
                    action_method = "PUT";
                }


                $.ajax({
                    url: action_url,
                    method:action_method,
                    data:$(this).serialize(),
                    dataType:"json",
                    success:function(data) {
                        var html = '';
                        if(data.errors) {
                            html = '<div class="alert alert-danger">';
                            for(var count = 0; count < data.errors.length; count++) {
                                html += '<p>' + data.errors[count] + '</p>';
                            }
                            html += '</div>';
                        }
                        if(data.success) {
                            html = '<div class="alert alert-success">' + data.success + '</div>';
                            $('#form_item')[0].reset();
                            $('#item_table').DataTable().ajax.reload();
                        }
                        $('#form_result').html(html);
                    }
                });
            });

            $(document).on('click', '.edit', function(){
                var id = $(this).attr('id');
                $('#form_result').html('');
                $.ajax({
                    url :"/items/"+id+"/edit",
                    dataType:"json",
                    success:function(data) {
                        $('#name').val(data.result.name);
                        $('#price').val(data.result.price);
                        $('#hidden_id').val(id);
                        $('.modal-title').text('{{trans("text.Edit")}} {{trans("text.Item")}}');
                        $('#action_button').val('{{trans("text.Edit")}}');
                        $('#action').val('Edit');
                        $('#formModal').modal('show');
                    }
                })
            });

            var item_id;

            $(document).on('click', '.delete', function(){
                item_id = $(this).attr('id');
                $('#confirmModal').modal('show');
            });

            $('#ok_button').click(function(){
                $.ajax({
                    url:"item/destroy/"+item_id,
                    success:function(data) {
                        setTimeout(function(){
                            $('#confirmModal').modal('hide');
                            $('#item_table').DataTable().ajax.reload();
                            alert('Data Deleted');
                        }, 2000);
                    }
                })
            });
        });
</script>
@stop